// -*- c++ -*-

#ifndef LEMON_CLEARABLE_GRAPH_EXTENDER_H
#define LEMON_CLEARABLE_GRAPH_EXTENDER_H

#include <lemon/invalid.h>


namespace lemon {

  template <typename _Base> 
  class ClearableGraphExtender : public _Base {
  public:

    typedef ClearableGraphExtender Graph;
    typedef _Base Parent;

    void clear() {
      Parent::getNodeObserverRegistry().clear();
      Parent::getEdgeObserverRegistry().clear();
      Parent::clear();
    }

  };

}

#endif
